# Daisy World of Watson and Lovelock
# Will Grey
# 15th May 2019

import random
import math
import matplotlib.pyplot as plt


def run_daisy_world():

ABSOLUTE_ZERO=273.15

# change these values to run different experiments
    
    area_black=0.25
    area_white=0.25
    area_ground = 1.0 - area_black - area_white
    
    alb_white=0.75
    alb_black=0.25
    alb_ground=0.5
    p=1.0
    death_rate=0.3
    S = 1000
    L=1.0
    sigma = 5.67032e-8
    q=20
    steps=500

    ab=[]
    aw=[] 
    ag=[]
    te=[]
    alb_p=[]

    alb_planet = area_black *  alb_black + area_white *  alb_white + area_ground * alb_ground
    t_planet=(L*S*(1-alb_planet)/sigma)**0.25
    
    
    for i in range(steps):

        x = p - area_white - area_black
        
        t_black = q * (alb_planet - alb_black) + t_planet
        t_white = q * (alb_planet - alb_white) + t_planet
        
        if  t_black >= 278.15 and t_black <= 313.15 and area_black >= 0.01:           
           birth_rate_black = 1.0 - 0.003265 * (22.5 + ABSOLUTE_ZERO +  - t_black)**2

        if  t_white >= 278.15 and t_white <= 313.15 and area_white >= 0.01:
            birth_rate_white = 1.0 - 0.003265 * (22.5 + ABSOLUTE_ZERO - t_white)**2

        d_area_black = area_black * (x * birth_rate_black - death_rate)
        d_area_white = area_white * (x * birth_rate_white - death_rate)

        area_black = area_black + d_area_black
        area_white = area_white + d_area_white
        area_ground = 1.0 - area_black - area_white
        alb_planet = (area_black *  alb_black) + (area_white *  alb_white) + (area_ground * alb_ground)
        t_planet=(L*S*(1-alb_planet)/sigma)**0.25
         
       # print(t_planet,t_black,t_white, area_black, area_white, area_ground, alb_planet,  birth_rate_black, birth_rate_white, d_area_black, d_area_white )

        ab.append(area_black)
        aw.append(area_white)
        ag.append(area_ground)
        alb_p.append(alb_planet)
        te.append(t_planet)

    return ab, aw, ag, te, alb_p


def plot_area(ab,aw):
    
    plt.title("Area")
    plt.xlabel("Time") 
    plt.ylabel("Area") 
    plt.xticks(rotation=90) 
    plt.plot(ab)
    plt.plot(aw)
    #plt.show()

    fig3 = plt.gcf() 
#    fig.subplots_adjust(bottom=0.2)
    fig3.savefig("daisy_world_area.png", format='png')


def plot_temperature(te):
    
    plt.title("Temperature")
    plt.xlabel("Time") 
    plt.ylabel("Temperature") 
    plt.xticks(rotation=90)
    plt.plot(te)
    #plt.show()

    fig1 = plt.gcf() 
   # fig.subplots_adjust(bottom=0.2)
    fig1.savefig("daisy_world_temperature.png", format='png')

def plot_albedo(alb_p):
    
    plt.title("Albedo")
    plt.xlabel("Time") 
    plt.ylabel("") 
    plt.xticks(rotation=90)
    #print(alb_p)
    plt.plot(alb_p)
    #plt.show()

    fig2 = plt.gcf() 
   # fig.subplots_adjust(bottom=0.2)
    fig2.savefig("daisy_world_albedo.png", format='png')

def main():
    ab, aw, ag, te, alb_p = run_daisy_world()
#    plot_area(ab,aw)
#    plot_temperature(te)
    plot_albedo(alb_p)
    
if __name__=="__main__":
    main()
